name := "funkcproggyak"

version := "0.1"

scalaVersion := "2.13.1"
libraryDependencies += "org.scalactic" %% "scalactic" % "3.1.0"
libraryDependencies += "org.scalatest" %% "scalatest" % "3.1.0" % "test"
libraryDependencies += "org.scalafx" %% "scalafx" % "12.0.2-R18"

val osName: SettingKey[String] = SettingKey[String]("osName")

osName := (System.getProperty("os.name") match {
  case name if name.startsWith("Linux") => "linux"
  case name if name.startsWith("Mac") => "mac"
  case name if name.startsWith("Windows") => "win"
  case _ => throw new Exception("Unknown platform!")
})

val java11LibraryDependencies: Seq[ModuleID] =
  if (System.getProperty("java.version").startsWith("11."))
    Seq(
      "org.openjfx" % "javafx-base" % "11-ea+25",
      "org.openjfx" % "javafx-fxml" % "11-ea+25",
      "org.openjfx" % "javafx-graphics" % "11-ea+25",
      "org.openjfx" % "javafx-media" % "11-ea+25"
    )
  else
    Seq.empty

libraryDependencies ++= java11LibraryDependencies.map( _.classifier( osName.value ))
