package week03

trait MyList[T] {
  def filter(p: T=>Boolean): MyList[T]
  def map[U](f: T=>U): MyList[U]
  def foldLeft[U](init: U)(op: (U,T)=>U): U
}
case class Ures[T]() extends MyList[T] {
  override def filter(p: T=>Boolean) = this
  override def map[U](f: T=>U) = Ures[U]()
  override def foldLeft[U](init: U)(op: (U,T)=>U) = init
}
case class Nemures[T](head: T, tail: MyList[T]) extends MyList[T] {
  override def filter(p: T=>Boolean) = if (p(head)) Nemures(head, tail.filter(p) ) else tail.filter(p)
  override def map[U](f: T=>U) = Nemures( f(head), tail.map(f) )
  override def foldLeft[U](init: U)(op: (U,T)=>U) = tail.foldLeft( op(init,head) )( op )
}
object Eloadas extends App {
  val list = Nemures(1,Nemures(4,Nemures(2,Nemures(8,Ures()))))
  println(list.filter( _ > 4 ))
  println(list.map( _*2 ))
  println(list.foldLeft(0)( _+_ ))
}
