package week05

case object mySizeOf {
  def apply(s: String) = s.length
}

trait MyList {
  def foreach[U](f: Int => U): Unit
  def map(f: Int=>Int): MyList
  def filter(p: Int=>Boolean): MyList
  def withFilter(p: Int=>Boolean) = filter(p)
}
case object Ures extends MyList {
  override def foreach[U](f: Int => U) = ()
  override def map(f: Int=>Int) = Ures
  override def filter(p: Int=>Boolean) = Ures
}
case class Nemures(head: Int, tail: MyList) extends MyList {
  override def foreach[U](f: Int => U) = {
    f(head)
    tail.foreach(f)
  }
  override def map(f: Int=>Int) = Nemures(f(head), tail.map(f))
  override def filter(p: Int=>Boolean) = if(p(head)) Nemures(head, tail.filter(p)) else tail.filter(p)
}
object MyList {
  def apply() = Ures
  def apply(a: Int) = Nemures(a, Ures)
  def apply(a: Int, b: Int): Nemures = Nemures(a, Nemures(b, Ures))
  def apply(a: Int, b: Int, c: Int): Nemures = Nemures(a, MyList(b,c))
}



object Eloadas extends App {
  val list = 1 :: 4 :: 2 :: 8 :: 5 :: 7 :: Nil
  val list2 = List(1, 4, 2, 8, 5, 7)
  val list3 = Nil.::(7).::(5).::(8).::(2).::(4).::(1)
  println((list == list2) && (list2 == list3))  //true

  println( mySizeOf("dinnye") )  //prints 6

  list.foreach( { x => print(x + " ") } )

  val myList = MyList(1,4,2)
  println(myList)

  myList.foreach( x => print(x + " " ))
  println()

  for( elem <- myList ) print(elem + " ")
  println()

  for( n <- 1 to 10 ) { print(n + " ") }
  println()

  for( n <- 1.to(10) ) { print(n + " ") }
  println()

  val negyzetek = for (elem <- list) yield elem*elem
  println(negyzetek) //prints List(1, 16, 4, 64, 25, 49)

  val myNegyzetek = for (elem <- myList) yield elem*elem
  println(myNegyzetek)

  for(
    i <- 1 to 10;
    j <- 1 to i
  ) println( i + " * " + j + " = " + (i*j) )

  val myParosNegyzetek = for(elem <- myList if (elem%2 == 0) ) yield elem*elem
  println(myParosNegyzetek)

  val mapmap = for(
    i <- 1 to 10;
    j <- 1 to i
  ) yield (i*j)
  println(mapmap)

  val mapmap2 = (1 to 10).map( i => (1 to i).map( j => (i*j) ) )
  println(mapmap2)

  val mapmap3 = (1 to 10).flatMap( i => (1 to i).map( j => (i*j) ) )
  println(mapmap3)
}
